<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   xmlns:componente="br.com.desenv.framework.componente.*"
			   close="titlewindowCloseHandler(event)"  
			   creationComplete="creationCompleteHandler(event)" 
			   title="Cadastro de Parcela Pagamento Cartao"
			  maxWidth="1200" maxHeight="700"  
			   xmlns:visual="br.com.desenv.framework.component.visual.*"   xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
			   
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	
	<fx:Metadata>
		[Event(name="ParcelapagamentocartaoIncluidoEvent")]
		[Event(name="ParcelapagamentocartaoAtualizadoEvent")]
		[Event(name="ParcelapagamentocartaoExcluidoEvent")]
		[Event(name="ParcelapagamentocartaoSelecionadoEvent")]
		
	</fx:Metadata>

	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			import spark.events.TitleWindowBoundsEvent;
			
			import br.com.desenv.nepalign.vo.Parcelapagamentocartao;
			
			import br.com.desenv.nepalign.vo.PagamentoCartao;
			// Alguem passa a objeto para ca
			public var parcelapagamentocartao : Parcelapagamentocartao = new Parcelapagamentocartao();
			
			[Bindable]
			private var listaPagamentoCartao: ArrayCollection = new ArrayCollection();

			
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}
			
			private function limparListaCampo(): void
			{
// Lupa
				ignAutoCompletePagamentoCartao.limpar();
				ignTextInputDoubleValor.text = "";
				ignTextInputDateDataVencimento.text = "";
				ignTextInputIntegerNumero.text = "";
			}
			
			// Chama ao completar o carregamento da pagina
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				carregarListaValidacao();
				
				
				// Se e um novo cadastro
				if (isNaN(this.parcelapagamentocartao.id))
				{
					limparListaCampo();
				}
				// Se alguem passou o objeto
				else
				{

					if (this.parcelapagamentocartao.pagamentoCartao != null)
					{
						ignAutoCompletePagamentoCartao.itemSelecionado = parcelapagamentocartao.pagamentoCartao;
					}
					ignTextInputDoubleValor.text = this.parcelapagamentocartao.valor == 0.0?"":this.parcelapagamentocartao.valor.toString().replace(".", ",");

					ignTextInputDateDataVencimento.text = DateField.dateToString(this.parcelapagamentocartao.dataVencimento, "DD/MM/YYYY"); 

					ignTextInputIntegerNumero.text = this.parcelapagamentocartao.numero.toString();

				}
			}
			
			
			
			
			// Chama quando fecha a janela no X
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- SALVAR E ATUALIZAR  --------------------------------	
			private function buttonSalvar_clickHandler( event: MouseEvent ): void 
			{
				if (validar(event))
				{
					// Se e alteracao
					if (isNaN(parcelapagamentocartao.id) == false) 
					{
						//parcelapagamentocartao.pagamentoCartao = // Carregado via popup	
						parcelapagamentocartao.pagamentoCartao = ignAutoCompletePagamentoCartao.itemSelecionado as PagamentoCartao;			
						parcelapagamentocartao.valor =  ignTextInputDoubleValor.text == ""?NaN:parseFloat(ignTextInputDoubleValor.text.replace(",", "."));
						parcelapagamentocartao.dataVencimento = ignTextInputDateDataVencimento.text == ""?null:DateField.stringToDate(ignTextInputDateDataVencimento.text, "DD/MM/YYYY");
						parcelapagamentocartao.numero =  ignTextInputIntegerNumero.text == ""?NaN:parseInt(ignTextInputIntegerNumero.text);
						var remoteObjectAtualizar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("parcelapagamentocartaoService", atualizarResultHandler);	
						remoteObjectAtualizar.getOperation("atualizar").send(parcelapagamentocartao); 
					// Se e inclusao
					} 
					else 
					{
						parcelapagamentocartao.valor =  ignTextInputDoubleValor.text == ""?NaN:parseFloat(ignTextInputDoubleValor.text.replace(",", "."));

						parcelapagamentocartao.dataVencimento = ignTextInputDateDataVencimento.text == ""?null:DateField.stringToDate(ignTextInputDateDataVencimento.text, "DD/MM/YYYY");

						parcelapagamentocartao.numero =  ignTextInputIntegerNumero.text == ""?NaN:parseInt(ignTextInputIntegerNumero.text);

						var remoteObjectSalvar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("parcelapagamentocartaoService", salvarResultHandler);	
						remoteObjectSalvar.getOperation("salvar").send(parcelapagamentocartao); 
					}
				}	
			}

			
			// Depois que salva fecha a janela
			private function salvarResultHandler( event: ResultEvent ): void 
			{
				this.parcelapagamentocartao = event.result as Parcelapagamentocartao;
				this.dispatchEvent(new ResultEvent("ParcelapagamentocartaoIncluidoEvent",false, true, this.parcelapagamentocartao, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			// Depois que atualiza fecha a janela
			private function atualizarResultHandler( event: ResultEvent ): void 
			{
				this.parcelapagamentocartao = event.result as Parcelapagamentocartao;
				this.dispatchEvent(new Event("ParcelapagamentocartaoAtualizadoEvent"));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- LIMPAR  --------------------------------	
			protected function buttonLimpar_clickHandler(event:MouseEvent):void
			{
				limparListaCampo();
			}
						
// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
			protected function buttonPesquisarPagamentoCartao_clickHandler(event:MouseEvent):void
			{
				var pagamentoCartaoComponentePesquisa: PagamentoCartaoComponentePesquisa = new PagamentoCartaoComponentePesquisa();
				pagamentoCartaoComponentePesquisa.addEventListener("PagamentoCartaoSelecionadoEvent", atualizarPagamentoCartaoPorSelecaoResultHandler);
				UPCPopUpManager.instance.addPopUp(pagamentoCartaoComponentePesquisa, this, true);
				UPCPopUpManager.instance.centerWindow(pagamentoCartaoComponentePesquisa);
			}
			
			private function atualizarPagamentoCartaoPorSelecaoResultHandler(e:ResultEvent):void
			{
				var novoPagamentoCartao: PagamentoCartao = e.result as PagamentoCartao;
				ignAutoCompletePagamentoCartao.itemSelecionado = novoPagamentoCartao;
			}

			protected function buttonAdicionarPagamentoCartao_clickHandler(event:MouseEvent):void
			{
				var pagamentoCartaoComponenteCadastro: PagamentoCartaoComponenteCadastro = new PagamentoCartaoComponenteCadastro();
				pagamentoCartaoComponenteCadastro.addEventListener("PagamentoCartaoIncluidoEvent", atualizarPagamentoCartaoPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(pagamentoCartaoComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(pagamentoCartaoComponenteCadastro);
			}
			
			private function atualizarPagamentoCartaoPorInclusaoResultHandler(e:ResultEvent):void
			{
				var novoPagamentoCartao: PagamentoCartao = e.result as PagamentoCartao;
				ignAutoCompletePagamentoCartao.itemSelecionado = novoPagamentoCartao;
			}

			
// ---------------------------------- PESQUISAR AUTOR ABRINDO A LISTA  --------------------------------				
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<!-- <mx:Validator id="validatorObrigatorioSituacaoParcelapagamentocartao" property="selectedItem" required="true" source="{comboBoxSituacaoParcelapagamentocartao}" trigger="{comboBoxSituacaoParcelapagamentocartao}" triggerEvent="valueCommit"/> -->
		

		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>
					
	</fx:Declarations>
	

	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="720" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Pagamento Cartao:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoPagamentoCartao" styleName="labelValidacao" text="{ignAutoCompletePagamentoCartao.errorString}"/>
					<s:HGroup>
						<autoComplete:IgnAutoComplete idKeyName="id" palavraChave="id" id="ignAutoCompletePagamentoCartao" enviarArgumentos="true" destino="pagamentoCartaoService" funcaoChamada="listarPorObjetoFiltro" lenStartConsulta="3"  nomeClasseObjetoFiltro="br.com.desenv.nepalign.vo.PagamentoCartao" tabEnabled="true" />  
						<s:Button id="buttonPesquisarPagamentoCartao" width="30" label="..." click="buttonPesquisarPagamentoCartao_clickHandler(event)"/>
						<s:Button id="buttonAdicionarPagamentoCartao" width="30" label="+" click="buttonAdicionarPagamentoCartao_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Valor:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoValor" styleName="labelValidacao" text="{ignTextInputDoubleValor.errorString}"/>
					<visual:IgnTextInputDouble id="ignTextInputDoubleValor" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Data Vencimento:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDataVencimento" styleName="labelValidacao" text="{ignTextInputDateDataVencimento.errorString}"/>
					<visual:IgnTextInputDate id="ignTextInputDateDataVencimento" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Numero:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoNumero" styleName="labelValidacao"  text="{ignTextInputIntegerNumero.errorString}"/>
					<visual:IgnTextInputInteger id="ignTextInputIntegerNumero" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>




		</mx:GridRow>		
		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Button id="buttonSalvar" label="Salvar" click="buttonSalvar_clickHandler(event)"/>
				<s:Button id="buttonLimpar" label="Limpar" click="buttonLimpar_clickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>